#pragma once
#include "windows.h"

// Material properties per mesh subset
struct Material
{
	WCHAR   strName[MAX_PATH];

	D3DXVECTOR3 vAmbient;
	D3DXVECTOR3 vDiffuse;
	D3DXVECTOR3 vSpecular;

	int nShininess;
	float fAlpha;

	bool bSpecular;

	WCHAR   strTexture[MAX_PATH];
	union {
		ID3D10ShaderResourceView* pTextureRV10;
		__int64 __unused; // 64bit padding :-|
	};

	Material() {}

	Material( const D3DXVECTOR3 &diffuseColor ) {
		strTexture[0] = strName[0] = 0;

		vAmbient = diffuseColor;
		vDiffuse = diffuseColor;
		vSpecular = D3DXVECTOR3( 1.0f, 1.0f, 1.0f );
		nShininess = 0;
		fAlpha = 1.0f;
		bSpecular = false;
		pTextureRV10 = NULL;
	}

	void init() {
		strTexture[0] = strName[0] = 0;

		vAmbient = D3DXVECTOR3( 0.8f, 0.8f, 0.8f );
		vDiffuse = D3DXVECTOR3( 0.8f, 0.8f, 0.8f );
		vSpecular = D3DXVECTOR3( 1.0f, 1.0f, 1.0f );
		nShininess = 0;
		fAlpha = 1.0f;
		bSpecular = false;
		pTextureRV10 = NULL;
	}
};
