#define BOOST_MEM_FN_ENABLE_STDCALL 
#include <boost/mem_fn.hpp>

#include "readBack.h"

namespace LPV {
	ReadBackResult readBack( ID3D10Device *device, ID3D10Texture2D *texture, UINT mipSlice, UINT arraySlice ) {
		D3D10_TEXTURE2D_DESC originalDesc;
		texture->GetDesc( &originalDesc );

		// TODO: convert format? [5/13/2010 Andreas Kirsch]

		ID3D10Texture2D *stagingTexture;
		D3D10_TEXTURE2D_DESC_CPP copyDesc( originalDesc.Format, D3D10_USAGE_STAGING );
		copyDesc.setSize( originalDesc.Width >> mipSlice, originalDesc.Height >> mipSlice );
		copyDesc.noMipMapLevels();
		copyDesc.allowCPURead();

		HRESULT hr;
		V( device->CreateTexture2D( &copyDesc, NULL, &stagingTexture ) );

		device->CopySubresourceRegion( stagingTexture, 0, 0, 0, 0, texture, D3D10CalcSubresource( mipSlice, arraySlice, originalDesc.MipLevels ), NULL );

		return ReadBackResult( boost::shared_ptr< ID3D10Texture2D >( stagingTexture, boost::mem_fn( &ID3D10Texture2D::Release ) ) );
	}
}